%bcond_with perl_IPC_Run_enables_optional_test

Summary:       Perl module for interacting with child processes
Name:          perl-IPC-Run
Version:       20231003.0
Release:       3%{?dist}
License:       GPL+ or Artistic
URL:           https://metacpan.org/release/IPC-Run
Source0:       https://cpan.metacpan.org/modules/by-module/IPC/IPC-Run-%{version}.tar.gz

BuildRequires: coreutils findutils make perl-generators perl-interpreter perl(ExtUtils::MakeMaker) sed perl(bytes)
BuildRequires: perl(Carp) perl(constant) perl(Data::Dumper) perl(Errno) perl(Exporter)
BuildRequires: perl(Fcntl) perl(File::Basename) perl(File::Spec) perl(IO::Handle) perl(IO::Pty)
BuildRequires: perl(POSIX) perl(Scalar::Util) perl(strict) perl(Symbol) perl(vars)
BuildRequires: perl(Encode) perl(File::Temp) perl(IO::Tty) perl(Test::More) perl(warnings)
%if %{with perl_IPC_Run_enables_optional_test}
BuildRequires: perl(Readonly)
%endif
Requires:      perl(Data::Dumper)
Requires:      perl(File::Basename)
Requires:      perl(IO::Pty)
BuildArch:     noarch

%description
IPC::Run allows you run and interact with child processes using files, pipes, and pseudo-ttys. Both
system()-style and scripted usages are supported and may be mixed. Likewise, functional and OO API
styles are both supported and may be mixed.

Various redirection operators reminiscent of those seen on common Unix and DOS command lines are
provided.

%prep
%autosetup -n IPC-Run-%{version}

rm -f lib/IPC/Run/Win32*
rm -f t/win32_*
sed -i -e '/^lib\/IPC\/Run\/Win32.*/d' MANIFEST
sed -i -e '/^t\/win32_.*/d' MANIFEST

for file in eg/run_daemon eg/abuse/timers eg/abuse/blocking_debug_with_sub_coprocess ; do
    perl -pi -e 's,^#!.*/perl,%{__perl}, if ($. == 1)' "$file"
done

%if !%{with perl_IPC_Run_enables_optional_test}
rm t/readonly.t
sed -i -e '/^t/readonly\.t/d' MANIFEST
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changelog eg/ README.md
%{perl_vendorlib}/IPC/
%{_mandir}/man3/IPC::Run.3*
%{_mandir}/man3/IPC::Run::Debug.3*
%{_mandir}/man3/IPC::Run::IO.3*
%{_mandir}/man3/IPC::Run::Timer.3*

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20231003.0-3
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20231003.0-2
- Rebuilt for loongarch release

* Thu Dec 21 2023 Upgrade Robot <upbot@opencloudos.org> - 20231003.0-1
- Upgrade to version 20231003.0

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20200505.0-5
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 16 2023 Xiaojie Chen <jackxjchen@tencent.com> - 20200505.0-4
- Remove perl(:MODULE_COMPAT) which will be generated by perl-generators >= 1.15

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20200505.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20200505.0-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Feb 20 2023 Shuo Wang <abushwang@tencent.com> - 20200505.0-1
- initial build
